<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_Config.php,v 1.10 2007/01/03 11:17:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * XML操作クラス
 */
require_once SYL_INCLUDE_DIR . '/lib/SyL_XMLParserOperation.php';
/**
 * キャッシュクラス
 */
require_once SYL_INCLUDE_DIR . '/lib/SyL_Cache.php';

/** 
 * 設定ファイルを読み込むクラス
 *
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_Config.php,v 1.10 2007/01/03 11:17:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_Config extends SyL_XMLParserOperation
{
    /**
     * イベント名
     * 
     * @access private
     * @var string
     */
    var $event = '';
    /**
     * XMLファイル名
     * 
     * @access private
     * @var array
     */
    var $file_names = array();
    /**
     * 設定ファイル配列
     * 
     * @access private
     * @var array
     */
    var $config = array();
    /**
     * デフォルト実行順序
     * 
     * @param int
     */
    var $default_priority = 5;

    /**
     * コンストラクタ
     *
     * @access public
     * @param string XMLファイル名
     */
    function SyL_Config($file_name)
    {
        $this->file_names = explode(PATH_SEPARATOR, $file_name);
    }

    /**
     * 設定ファイルオブジェクトを取得
     *
     * @static
     * @access public
     * @param string イベント名
     * @param string 設定ファイルオブジェクト名
     * @param string 設定ファイル名
     * @param object コントローラオブジェクト
     * @return object SyL_Containerオブジェクト
     */
    function &getObject($config_name, $file_name, &$controller, $event='')
    {
        $class_name = 'SyL_Config' . ucfirst($config_name);
        include_once SYL_INCLUDE_DIR . "/framework/Config/{$class_name}.php";
        $obj =& new $class_name($file_name);
        $obj->setController($controller);
        $obj->setEvent($event);
        return $obj;
    }

    /**
     * コントローラをセット
     *
     * @access public
     * @param object コントローラオブジェクト
     */
    function setController(&$controller)
    {
    }

    /**
     * イベント名をセット
     *
     * @access public
     * @param string イベント名
     */
    function setEvent($event)
    {
        $this->event = $event;
    }

    /**
     * 複数のXMLファイルの解析する
     *
     * @access public
     */
    function parseXML()
    {
        $config = array();
        foreach ($this->file_names as $file_name) {
            parent::setFile($file_name);
            parent::parseXML();
            if (is_array($this->config)) {
                $config += $this->config;
            }
            // 初期化
            $this->config = array();
        }
        $this->config = $config;
    }

    /**
     * XMLデータ内容取得ハンドラメソッド
     * ※オーバーライド
     *
     * @access protected
     * @param string 現在XML解析中のパス
     * @param string XMLのタグの属性値
     * @param string XMLのタグの値
     */
    function getElement($current_path, $attribute, $text)
    {
    }

    /**
     * XML設定値を取得
     * 
     * @return array 設定値配列
     */
    function getConfig()
    {
        return $this->config;
    }
}

?>
